/*   -*- buffer-read-only: t -*- vi: set ro:
 *
 *  DO NOT EDIT THIS FILE   (stdin.c)
 *
 *  It has been AutoGen-ed
 *  From the definitions    stdin
 *  and the template file   str2enum
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. Neither the name ``Bruce Korb'' nor the name of any other
 *    contributor may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * str2enum IS PROVIDED BY Bruce Korb ``AS IS'' AND ANY EXPRESS
 * OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL Bruce Korb OR ANY OTHER CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
 * OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
 * ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#include "cm-opt.h"
#include <ctype.h>
#include <string.h>
/* ANSI-C code produced by gperf version 3.0.4 */
/* Command-line: gperf cm-opt.gp  */
/* Computed positions: -k'1' */



# if 0 /* gperf build options: */
// %struct-type
// %language=ANSI-C
// %includes
// %global-table
// %omit-struct-type
// %readonly-tables
// %compare-strncmp
//
// %define slot-name               cm_name
// %define hash-function-name      cm_opt_hash
// %define lookup-function-name    find_cm_opt_name
// %define word-array-name         cm_opt_table
// %define initializer-suffix      ,CM_COUNT_CMD
//
# endif

#include "cm-opt.h"
typedef struct {
    char const *    cm_name;
    cm_opt_enum_t cm_id;
} cm_opt_map_t;
#include <string.h>

/* maximum key range = 11, duplicates = 0 */

static unsigned int
cm_opt_hash (register const char *str, register unsigned int len)
{
  static const unsigned char asso_values[] =
    {
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15,  0,  5,
      15, 10,  5,  5, 15, 15, 15, 15, 15, 15,
      15,  0,  0, 15, 15, 15,  0, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15, 15, 15, 15, 15,
      15, 15, 15, 15, 15, 15
    };
  return len + asso_values[(unsigned char)str[0]];
}

static const cm_opt_map_t cm_opt_table[] =
  {
    {"",CM_COUNT_CMD}, {"",CM_COUNT_CMD}, {"",CM_COUNT_CMD},
    {"",CM_COUNT_CMD},
    {"test",     CM_CMD_TEST},
    {"table",    CM_CMD_TABLE},
    {"backup",   CM_CMD_BACKUP},
    {"pthread",  CM_CMD_PTHREAD},
    {"optimize", CM_CMD_OPTIMIZE},
    {"file",     CM_CMD_FILE},
    {"guard",    CM_CMD_GUARD},
    {"",CM_COUNT_CMD},
    {"comment",  CM_CMD_COMMENT},
    {"",CM_COUNT_CMD},
    {"emit",     CM_CMD_EMIT}
  };

static inline const cm_opt_map_t *
find_cm_opt_name (register const char *str, register unsigned int len)
{
  if (len <= 8 && len >= 4)
    {
      register int key = (int)cm_opt_hash (str, len);

      if (key <= 14 && key >= 0)
        {
          register const char *s = cm_opt_table[key].cm_name;

          if (*str == *s && !strncmp (str + 1, s + 1, len - 1) && s[len] == '\0')
            return &cm_opt_table[key];
        }
    }
  return 0;
}

/**
 * Convert a command (keyword) to a cm_opt_enum_t enumeration value.
 * The length of the command is computed by calling \a strspn()
 * on the input argument.
 *
 * @param[in] str   a string that should start with a known key word.
 * @returns the enumeration value.
 * If not found, that value is CM_INVALID_CMD.
 */
cm_opt_enum_t
find_cm_opt_cmd(char const * str)
{
    cm_opt_map_t const * map;
    static char const accept[] =
        "ABCDEFGHIKLMNOPRSTUZabcdefghiklmnoprstuz";
    unsigned int clen = strspn(str, accept);
    char name_buf[9];
    unsigned int ix;

    /* too short, too long or followed immediately by a name char... */
    if (  (clen < 4)
       || (clen > 8)
       || isalnum((unsigned char)str[clen]) )
        return CM_INVALID_CMD;

    for (ix = 0; ix < clen; ix++) {
        int ch = (unsigned char)str[ix];
        name_buf[ix] = tolower(ch);
    }
    str = name_buf;
    map = find_cm_opt_name(str, (unsigned int)clen);
    return (map == NULL) ? CM_INVALID_CMD : map->cm_id;
}


/**
 * Dispatch a cm_opt function, based on the keyword.
 *
 * @param[in] str  a string that should start with a known key word.
 * @returns char *, returned by the dispatched function.
 */
char *
handle_cm_opt_disp(char const * str)
{
    static handle_hdl_t * const dispatch[11] = {
        [CM_CMD_BACKUP  ] = handle_backup,
        [CM_CMD_COMMENT ] = handle_comment,
        [CM_CMD_EMIT    ] = handle_emit,
        [CM_CMD_FILE    ] = handle_file,
        [CM_CMD_GUARD   ] = handle_guard,
        [CM_CMD_OPTIMIZE] = handle_optimize,
        [CM_CMD_PTHREAD ] = handle_pthread,
        [CM_CMD_TABLE   ] = handle_table,
        [CM_CMD_TEST    ] = handle_test,
        [CM_INVALID_CMD ] = handle_invalid };
    static unsigned int keywd_len[] = {
        [CM_CMD_BACKUP  ] = 6,
        [CM_CMD_COMMENT ] = 7,
        [CM_CMD_EMIT    ] = 4,
        [CM_CMD_FILE    ] = 4,
        [CM_CMD_GUARD   ] = 5,
        [CM_CMD_OPTIMIZE] = 8,
        [CM_CMD_PTHREAD ] = 7,
        [CM_CMD_TABLE   ] = 5,
        [CM_CMD_TEST    ] = 4 };
    cm_opt_enum_t id = find_cm_opt_cmd(str);
    unsigned int klen = keywd_len[id];
    handle_hdl_t * disp = dispatch[id];
    if (disp == NULL)
        disp = dispatch[CM_INVALID_CMD];
    return disp(id, str + klen);
}

/* end of cm-opt.c */
